
Extended Profile - Bug #1852

Anonymous User is not exists error when the db is empty(loaded the default data)

15 Sep 2011 01:55 - Riceball LEE

Status: Closed Start date: 15 Sep 2011

Priority: Major Due date: 20 Oct 2011

Assignee: Andriy Lesyuk % Done: 100%

Category:  Estimated time: 0.00 hour

Target version: 0.0.3   

Redmine version:  External issue:  

Description

[workaround]

mv the extened_profile folder to another folder.

restart and refresh the redmine page once.

mv the extended_profile plugin back.

Associated revisions

Revision 23 - 20 Oct 2011 17:24 - Andriy Lesyuk

Included changes for #1852

History

#1 - 15 Sep 2011 07:39 - Andriy Lesyuk

- Status changed from New to Open

- Assignee set to Andriy Lesyuk

Did not get. How to reproduce the issue?

#2 - 16 Sep 2011 02:54 - Riceball LEE

Reproducing Steps

1. ensure the extened_profile in the vender/plugins dir

2. remove/empty the database, such as: db/production.sqlte3

3. rake db:migrate

4. rake db:load_default_datas

5. rake db:migrate_plugins

6. ruby script/server

#3 - 16 Sep 2011 13:46 - Andriy Lesyuk

How do the plugin behave in this case?.. Gives error?

#4 - 17 Sep 2011 06:00 - Riceball LEE

Need logout first(if cookie is not clear). then u can get the error:

Processing WelcomeController#index (for 127.0.0.1 at 2011-09-17 13:59:15) [GET]

  Parameters: {"action"=>"index", "controller"=>"welcome"}

  SQL (0.2ms)   SELECT max("settings".updated_on) AS max_updated_on FROM "settings" 

Cache read: chiliproject/setting-cleared_on
Cache miss: chiliproject/setting/rest_api_enabled ({})

  Setting Load (0.2ms)   SELECT * FROM "settings" WHERE ("settings"."name" = 'rest_api_enabled') LIMIT 1

Cache write (will save 2.47ms): chiliproject/setting/rest_api_enabled

  AnonymousUser Load (0.2ms)   SELECT * FROM "users" WHERE ( ("users"."type" = 'AnonymousUser' ) ) LIMIT 1

WARNING: Can't mass-assign these protected attributes: login

  CACHE (0.0ms)   SELECT * FROM "users" WHERE ( ("users"."type" = 'AnonymousUser' ) ) LIMIT 1

RuntimeError (Unable to create the anonymous user.):

  app/models/user.rb:502:in `anonymous'

  app/models/user.rb:493:in `current'

  app/controllers/application_controller.rb:106:in `check_if_login_required'

  /System/Library/Frameworks/Ruby.framework/Versions/1.8/usr/lib/ruby/1.8/webrick/httpserver.rb:104:in `servic

e'

  /System/Library/Frameworks/Ruby.framework/Versions/1.8/usr/lib/ruby/1.8/webrick/httpserver.rb:65:in `run'

  /System/Library/Frameworks/Ruby.framework/Versions/1.8/usr/lib/ruby/1.8/webrick/server.rb:173:in `start_thre

ad'

  /System/Library/Frameworks/Ruby.framework/Versions/1.8/usr/lib/ruby/1.8/webrick/server.rb:162:in `start'

  /System/Library/Frameworks/Ruby.framework/Versions/1.8/usr/lib/ruby/1.8/webrick/server.rb:162:in `start_thre

ad'

  /System/Library/Frameworks/Ruby.framework/Versions/1.8/usr/lib/ruby/1.8/webrick/server.rb:95:in `start'

  /System/Library/Frameworks/Ruby.framework/Versions/1.8/usr/lib/ruby/1.8/webrick/server.rb:92:in `each'

  /System/Library/Frameworks/Ruby.framework/Versions/1.8/usr/lib/ruby/1.8/webrick/server.rb:92:in `start'

  /System/Library/Frameworks/Ruby.framework/Versions/1.8/usr/lib/ruby/1.8/webrick/server.rb:23:in `start'

  /System/Library/Frameworks/Ruby.framework/Versions/1.8/usr/lib/ruby/1.8/webrick/server.rb:82:in `start'

#5 - 17 Sep 2011 06:17 - Riceball LEE

I got the reason:

The problem is in the ExtendedUserPatch:

validates_presence_of :extended_profile

 

comment it the anonymous user can be created.

#6 - 17 Sep 2011 08:35 - Riceball LEE

Change to this to avoid the problem:
            validates_presence_of :extended_profile, :unless => Proc.new { |user| user.is_a?(AnonymousUser) }

#7 - 17 Sep 2011 10:44 - Andriy Lesyuk

- Priority changed from Critical to Major

- Target version set to 0.0.3

Good find! Thank you!

#8 - 20 Oct 2011 15:57 - Mario Luzeiro

Its happen same here, any news about it?

#9 - 20 Oct 2011 17:26 - Andriy Lesyuk

- Due date set to 20 Oct 2011

- Status changed from Open to In Progress

- % Done changed from 0 to 100

Just committed changes suggested by Riceball. Can anyone test and confirm?

#10 - 22 Oct 2011 08:41 - Andriy Lesyuk

- Status changed from In Progress to Closed

Well... I believe it has been fixed!
